<template>
	<a-row type="flex" justify="center">
        <a-col :span="10">
        	<a-spin :spinning="state.loading" size="large">
        		<a-icon slot="indicator" type="loading" spin />
		      	<a-card title="Войти в систему">
		      		<!-- <a href="#" slot="extra">Не помню пароль</a> -->
		      		<div class="mb-3">
				    	<a-input @keyup.enter.native="authMe" placeholder="Введите ваш почтовый адрес" v-model="auth.email"/>
		      		</div>
		      		<div class="mb-3">
				    	<a-input @keyup.enter.native="authMe" type="password" placeholder="Введите ваш пароль" v-model="auth.password"/>
		      		</div>
		      		<div class="mb-3">
		      			<a-checkbox :checked="saveUser" @change="savingUser">Запомнить меня</a-checkbox>
		      		</div>
		      		<div class="mb-3">
		      			<a-button type="primary" v-on:click="authMe" :style="{ width: '100%' }">Войти</a-button>
		      		</div>
				</a-card>	
        	</a-spin>
        </a-col>
    </a-row>
</template>

<script type="text/javascript">
	export default {
		data() {
			return {
				saveUser: true,
				state: {
					loading: false
				},
				auth: {
					email: '',
					password: ''
				}
			}
		},
		created () {
			this.auth.email = this.$localStorage.get('access_user');
			this.auth.password = this.$localStorage.get('access_password');
		},
		methods: {
			savingUser () {
				this.saveUser = !this.saveUser;
			},
			authMe() {
				this.state.loading = true;
				this.checkCredentals();
			},
			checkCredentals() {
				let data = {
					grant_type: this.$store.state.api.grant_type,
					client_id: this.$store.state.api.client_id,
					client_secret: this.$store.state.api.client_secret,
					scopes: this.$store.state.api.scopes,
					username: this.auth.email,
					password: this.auth.password,
				}
				this.$http.post(this.$store.state.api.root+'oauth/token', data).then(this.authSuccess, this.authError);
			},
			authSuccess(data) {
				this.$localStorage.set('access_token', data.body.access_token);
				if (this.saveUser) {
					this.$localStorage.set('access_user', this.auth.email);
					this.$localStorage.set('access_password', this.auth.password);
				} else {
					this.$localStorage.remove('access_user');
					this.$localStorage.remove('access_password');
				}
				this.$router.push({ name: 'UsersPage' });
				this.state.loading = false;
			},
			authError(err) {
				console.log(err);
				if (err.status === 400 || err.status === 401) {
					this.openNotification('error', 'Ошибка', 'Не верный логин или пароль!');	
				}
				if (err.status === 500) {
					this.openNotification('error', 'Ошибка', 'Во время выполнения операции произошла серьезная ошибка! Обратитесь к администратору.');
				}
				this.state.loading = false;
			},
			openNotification(type, title, text) {
				this.$notification[type]({
		          message: title,
		          description: text,
		        });
			}
		}
	}
</script>